# NcsNorms

NcsNorms is a package written in R that accompanies the article:
Deriving Reference Values for Nerve Conduction Studies from Existing Data Using Mixture Model Clustering 

## Installation

To run the scripts you should install the [programming language R](https://cran.r-project.org/) and the 
integrated development environment (IDE) called [RStudio](https://rstudio.com/products/rstudio/download/).
After installation of these two programs you can download the files in this repository. 
If you're an experienced programmer you can choose to clone this repository with git.
If you're not familiar with git just download the current version of this 
repository by clicking the download button above and choosing to download all the files
as a zip file. The download button doesn't have a name but is located between the
blue "Clone" button and the "Web IDE" button.

After downloading the zip file unpack it and go to the ReferenceValues-master folder.
If you have installed RStudio you can doubleclick on the NcsNorms.Rproj file. This will open
the project in RStudio. The Right-Bottom Pane in RStudio has the tabs, Files - Plots -
Packages - Help and Viewer. Click on the Files tab and open the scripts/Create folder.
Open the file "scriptPackageInstaller.R" in the scripts/create folder in RStudio. 
Run this file by checking the "Source on Save" Checkbox above the editor pane. 
Now click on the save button left of the "Source on Save" Checkbox. 
The script will install all needed packages and create a folder structure for the generated results.

After you have run this script in RStudio click the Build tab in the right 
top pane. Click the “More” button and then the “Configure Build Tools…” menu item.
Press the Configure button in the Project Options Dialog. Check the checkboxes like in the picture below.

![Configuration Dialog](./Configuration.png)
Press OK and go back to the Build pane. Click the "Install and Restart" button. 
The library will now be compiled and installed.

Now you can open the "scriptRunAll.R" file in the scripts/create folder. 
When this file is run, mixture model clustering (MMC) is performed on a dataset 
of nerve conduction studies and the results of the clustering are saved. 
After this script has run reports and images are created in the results folder of the project.


The calculations can take a very long time. 
This is because not only do we show examples of MMC with linear models like in 
the article but we also perform MMC with linear mixed models. 
MMC with linear mixed models can take a very long time. 
Take into account a calculation time of several hours on a fast PC.


## Files Generated by the package

There's a script `scriptRunAll.R` that runs all scripts. After all scripts are run you 
can find reports, tables and figures created by the scripts in the results folder of the package.

If you don't want to run the scripts yourself, on the wiki page of this gitlab repository you can find an overview of the reports that are created: 
[wiki](https://gitlab.com/lumc/clinicalneurophysiology/ReferenceValues/-/wikis/home)

